Subject: Re: [netmod] Query on Announcing Conformance Information in the <hello> Message

From: Martin Bjorklund <[email-masked]>
Date: Tue, 02 May 2017 10:25:09 +0200 (CEST)

Robert Varga <[email-masked]> wrote:
> On 20/04/17 18:35, Andy Bierman wrote:
> > 
> > Yes -- it looks correct.
> > The structure is defined in RFC 6020:
> > https://tools.ietf.org/html/rfc6020#section-5.6.4
> > 
> 
> Hello Andy,
> 
> One thing that is not quite clear in RFC6020 due to not being clear what
> 'supported module' means.

Right; specifically the difference between "implement" and "support
for import", which is clarified in RFC 7950 and RFC 7895.

> Should deviations be applied in case a module is advertised, but is not
> mentioned in a deviations parameter like this:

No.

>    <hello xmlns="urn:ietf:params:xml:ns:netconf:base:1.0">
>        <capability>
>          http://example.com/syslog?module=syslog
>        </capability>
>        <capability>
>          http://example.com/my-deviations?module=my-devs
>        </capability>
>      </hello>
> 
> If not, does this imply that any deviation statement targeting an
> external module, which does not have a matching deviations parameter
> should silently be ignored?

Yes.  Just like a grouping can be defined without ever being used.

For example, a device might put all its deviations in a
single module, but then list it in the deviations parameter for a
subset of all potential modules.

/martin

---

From: Robert Varga <[email-masked]>
Date: Tue, 2 May 2017 14:37:30 +0200

> subset of all potential modules.

Thanks Martin,

this does make sense, but there seems to be little implied about this in
the text of https://tools.ietf.org/html/rfc7950#section-7.20.3.

Furthermore https://tools.ietf.org/html/rfc7950#section-7.20.3.3 is a
bit misleading, as it states:

   A server would advertise both modules "example-base" and
   "example-deviations".

Based on your reply, it is not sufficient to advertise both modules as
'implement', but rather for 'deviation' statements to be effective,
'example-deviations' needs to also be present in example-base's
advertised deviation list.

Maybe 7.20.3 could use a paragraph describing interplay with
advertisement and the text in 7.20.3.3 could be made more explicit?

Regards,
Robert